#include "main.h"

BITMAP *buffer;
DATAFILE *data;

PLAYER player;

int length;
int angle;
int angle_stepsize;
int troll_x;
int troll_y;
void troll(void);

volatile int game_time;
volatile int game_count;
bool game_music;

int game_mode = TITLE_MODE;



void game_timer(void)
{
	game_time++;
}

END_OF_FUNCTION(game_timer);



void game_counter(void)
{
	game_count++;
}

END_OF_FUNCTION(game_counter);



void game_exit (void)
{
	game_mode = EXIT_MODE;
}



void troll(void)
{
	if (fixtoi(troll_x) - int(player.x_pos) > 1000)
		angle = int(player.x_pos) - TILE_SIZE;

	troll_x = angle;
	troll_y = length*fsin(angle);

	//rect(buffer, fixtoi(x_pos), fixtoi(y_pos)+SCREEN_H/2, fixtoi(x_pos)+TILE_SIZE, fixtoi(y_pos)+SCREEN_H/2+TILE_SIZE, makecol (255, 255, 255));

	angle += itofix(10);
}



void game_play(void)
{
	if (!game_music)
	{
		play_midi((MIDI*)data[BOOGIE].dat, TRUE);
		game_music = true;
	}

	player.control();
	player.drop();
	
	clear_to_color(buffer, makecol(0, 0, 255));

	player.draw();
	troll();

	blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}



int main(void)
{
	length = 50;
	angle_stepsize = itofix(5);
	
	allegro_init();

	install_keyboard();
	install_mouse();
	install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);

	set_color_depth(16);
	set_gfx_mode(GFX_AUTODETECT_WINDOWED, 320, 240, 0, 0);


	set_volume(160, 127);
	set_window_close_button(true);
	set_window_close_hook(game_exit);

	buffer = create_bitmap(SCREEN_W, SCREEN_H);
	data = load_datafile("data.dat");

	text_mode(-1);

	LOCK_VARIABLE(game_time);
	LOCK_VARIABLE(game_count);
	LOCK_FUNCTION(game_timer);
	LOCK_VARIABLE(game_counter);

	install_int_ex(game_counter, BPS_TO_TIMER(60));
	install_int_ex(game_timer, BPS_TO_TIMER(1));

	while (game_mode)
	{
		while (game_count)
		{
			switch (game_mode)
			{
			case EXIT_MODE:
				game_exit();
				break;
			case TITLE_MODE:
				game_title();
				break;
			case GAME_MODE:
				game_play();
				break;
			}

			game_count = 0;
		}
	}

	destroy_bitmap(buffer);
	unload_datafile(data);
	allegro_exit();
	return 0;
}

END_OF_MAIN()