#include <allegro.h>
#include "data.h"

#define EXIT_MODE 0
#define TITLE_MODE 1
#define CONFIG_MODE 2
#define GAME_MODE 3
#define EDIT_MODE 4

#define TILE_SIZE 16
#define FIELD_W 320
#define FIELD_H 15

#define PLAYER_X 16
#define PLAYER_Y 160



class PLAYER
{
private:
	float x_vel;
	float y_vel;
	int screen_x;
	int field_x;
	int l;
	int h;
	int l_max;
	int h_max;
	int count;
	int sprite;
	int frame;
	int state;
public:
	PLAYER();
	~PLAYER();
	float x_pos;
	float y_pos;
	void control(void);
	void move(int x);
	void pedal(void);
	void jump(void);
	void draw(void);
	void drop(void);
};







extern PLAYER player;

extern BITMAP *buffer;
extern DATAFILE *data;

extern void game_exit (void);
extern void game_title(void);

extern volatile int game_time;
extern volatile int game_count;

extern int game_mode;
extern bool game_music;

extern int length;
extern int angle;
extern int angle_stepsize;
extern int troll_x;
extern int troll_y;
extern void troll(void);