#include "main.h"



PLAYER::PLAYER()
{
	x_pos = PLAYER_X;
	y_pos = PLAYER_Y;
}



PLAYER::~PLAYER() {}



void PLAYER::control(void)
{
	if (key[KEY_ESC])
		game_exit();
	if (key[KEY_Z])
		jump();
	if (key[KEY_X])
		pedal();

	if (key[KEY_LEFT])
		move(-1);
	if (key[KEY_RIGHT])
		move(1);

}



void PLAYER::move(int x)
{
	if (screen_x < 0)
		screen_x = 0;
	else if (screen_x > SCREEN_W - TILE_SIZE)
		screen_x = SCREEN_W - TILE_SIZE;
	else
		screen_x += x;
}



void PLAYER::pedal(void)
{
	if (y_pos == PLAYER_Y)
		if (x_vel<60)
			x_vel += (0.2);
}



void PLAYER::jump(void)
{
	if (y_pos == PLAYER_Y)
	{
		y_vel = -x_vel/10-2;
		/*
		if (state == 0)
			y_vel = -3.65;

		if (state == 1)
			y_vel = -3.40;

		if (state == 2)
			y_vel = -3.18;

		if (state == 3)
			y_vel = -2.88;
			*/

		//play_sample((SAMPLE*)data[SAMP_TEXT].dat, 127, 64+(0.2)*player.x_pos, 1000, FALSE);
	}

	if (y_vel < PLAYER_Y)
		y_vel = y_vel - (0.1);
}



void PLAYER::drop(void)
{
	x_vel -= (0.1);
	y_vel = y_vel + (0.2);

	if (x_vel < (1))
		x_vel = (1);

	x_pos = x_pos + x_vel;
	y_pos = y_pos + y_vel;

	if (y_pos > PLAYER_Y)
	{
		y_pos = PLAYER_Y;
		y_vel = 0;
	}
}



void PLAYER::draw()
{
	field_x = -int(x_pos)%800;
	blit((BITMAP*)data[TILESET].dat, buffer, 0, 0, field_x, 0, 800, SCREEN_H);
	blit((BITMAP*)data[TILESET].dat, buffer, 0, 0, field_x+800, 0, 800, SCREEN_H);

	textprintf(buffer, font, 0, 0, makecol(255, 255, 255),  "speed:   %6d", (int)x_vel);
	textprintf(buffer, font, 0, 8, makecol(255, 255, 255),  "player_x %6d", int(x_pos));
	textprintf(buffer, font, 0, 16, makecol(255, 255, 255), "troll_x  %6d", fixtoi(x_pos));

	masked_blit((BITMAP*)data[MORMON].dat, buffer, 64*frame, 64*sprite, screen_x, y_pos, 64, 64);

	masked_blit((BITMAP*)data[TROLL].dat, buffer, 0, 0, fixtoi(troll_x)-x_pos, fixtoi(troll_y)+SCREEN_H/2-64, 64, 64);
}
